;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.1.0 #12072 (Linux)
;--------------------------------------------------------
	.module uart_tbasic
	.optsdcc -mstm8
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _uart_putchar
	.globl _uart_putstring
	.globl _uart_getchar
	.globl _uart_ischar
	.globl _uart_init
	.globl _readint
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area DABS (ABS)

; default segment ordering for linker
	.area HOME
	.area GSINIT
	.area GSFINAL
	.area CONST
	.area INITIALIZER
	.area CODE

;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME
	.area GSINIT
	.area GSFINAL
	.area GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME
	.area HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CODE
;	../src/uart_tbasic.c: 52: void uart_putchar(char ch)
;	-----------------------------------------
;	 function uart_putchar
;	-----------------------------------------
_uart_putchar:
;	../src/uart_tbasic.c: 54: while(!(USARTx_SR & USART_SR_TXE));   // warten bis letztes Zeichen gesendet ist
00101$:
	ld	a, 0x5230
	jrpl	00101$
;	../src/uart_tbasic.c: 55: USARTx_DR = ch;                       // Zeichen senden
	ldw	x, #0x5231
	ld	a, (0x03, sp)
	ld	(x), a
;	../src/uart_tbasic.c: 56: }
	ret
;	../src/uart_tbasic.c: 59: void uart_putstring(char *p)
;	-----------------------------------------
;	 function uart_putstring
;	-----------------------------------------
_uart_putstring:
;	../src/uart_tbasic.c: 61: do
	ldw	x, (0x03, sp)
00101$:
;	../src/uart_tbasic.c: 63: uart_putchar( *p );
	ld	a, (x)
	pushw	x
	push	a
	call	_uart_putchar
	pop	a
	popw	x
;	../src/uart_tbasic.c: 64: } while( *p++);
	ld	a, (x)
	incw	x
	tnz	a
	jrne	00101$
;	../src/uart_tbasic.c: 65: }
	ret
;	../src/uart_tbasic.c: 74: char uart_getchar(void)
;	-----------------------------------------
;	 function uart_getchar
;	-----------------------------------------
_uart_getchar:
;	../src/uart_tbasic.c: 76: while(!(USARTx_SR & USART_SR_RXNE));    // solange warten bis ein Zeichen eingetroffen ist
00101$:
	ld	a, 0x5230
	bcp	a, #0x20
	jreq	00101$
;	../src/uart_tbasic.c: 77: return USARTx_DR;
	ld	a, 0x5231
;	../src/uart_tbasic.c: 78: }
	ret
;	../src/uart_tbasic.c: 86: char uart_ischar(void)
;	-----------------------------------------
;	 function uart_ischar
;	-----------------------------------------
_uart_ischar:
;	../src/uart_tbasic.c: 88: return (USARTx_SR & USART_SR_RXNE);
	ld	a, 0x5230
	and	a, #0x20
;	../src/uart_tbasic.c: 89: }
	ret
;	../src/uart_tbasic.c: 176: void uart_init(void)
;	-----------------------------------------
;	 function uart_init
;	-----------------------------------------
_uart_init:
;	../src/uart_tbasic.c: 179: PD_DDR |= (1 << PD4);                                 // TxD Leitung als Output
	bset	20497, #4
;	../src/uart_tbasic.c: 180: PD_CR1 |= (1 << PD4);
	bset	20498, #4
;	../src/uart_tbasic.c: 182: USARTx_CR2 |= USART_CR2_TEN;                          // TxD enabled
	ld	a, 0x5235
	or	a, #0x08
;	../src/uart_tbasic.c: 183: USARTx_CR2 |= USART_CR2_REN;                          // RxD enable
	ld	0x5235, a
	or	a, #0x04
	ld	0x5235, a
;	../src/uart_tbasic.c: 184: USARTx_CR3 &= ~(USART_CR3_STOP1);                     // Stopbit
	bres	21046, #4
;	../src/uart_tbasic.c: 186: USARTx_BRR1 = 0x34;
	mov	0x5232+0, #0x34
;	../src/uart_tbasic.c: 187: USARTx_BRR2 = 0x02;
	mov	0x5233+0, #0x02
;	../src/uart_tbasic.c: 188: }
	ret
;	../src/uart_tbasic.c: 200: int16_t readint(void)
;	-----------------------------------------
;	 function readint
;	-----------------------------------------
_readint:
	sub	sp, #4
;	../src/uart_tbasic.c: 202: uint8_t   signflag= 0;
	clr	(0x01, sp)
;	../src/uart_tbasic.c: 203: uint16_t  sum = 0;
	clrw	x
	ldw	(0x03, sp), x
;	../src/uart_tbasic.c: 207: do
00126$:
;	../src/uart_tbasic.c: 209: ch= uart_getchar();
	call	_uart_getchar
;	../src/uart_tbasic.c: 210: if (ch== 0x0a) ch= 0x0d;
	ld	(0x02, sp), a
	cp	a, #0x0a
	jrne	00102$
	ld	a, #0x0d
	ld	(0x02, sp), a
00102$:
;	../src/uart_tbasic.c: 213: if ((ch>= '0') && (ch<= '9'))
	ld	a, (0x02, sp)
	cp	a, #0x30
	jrc	00113$
	cp	a, #0x39
	jrugt	00113$
;	../src/uart_tbasic.c: 215: zif= ch-'0';
	ld	a, (0x02, sp)
	sub	a, #0x30
;	../src/uart_tbasic.c: 217: if ((sum== 0) && (zif))        // erste Ziffer
	ldw	x, (0x03, sp)
	jrne	00109$
	tnz	a
	jreq	00109$
;	../src/uart_tbasic.c: 219: sum= zif;
	clrw	x
	ld	xl, a
	ldw	(0x03, sp), x
;	../src/uart_tbasic.c: 220: uart_putchar(ch);
	ld	a, (0x02, sp)
	push	a
	call	_uart_putchar
	pop	a
	jra	00113$
00109$:
;	../src/uart_tbasic.c: 223: if (sum < 3277)
	ldw	x, (0x03, sp)
	cpw	x, #0x0ccd
	jrnc	00113$
;	../src/uart_tbasic.c: 225: if  (!( ((sum * 10) > 32750) && (zif > 7) ))
	pushw	x
	sllw	x
	sllw	x
	addw	x, (1, sp)
	sllw	x
	addw	sp, #2
	cpw	x, #0x7fee
	jrule	00103$
	cp	a, #0x07
	jrugt	00113$
00103$:
;	../src/uart_tbasic.c: 227: sum= (sum*10) + zif;
	clrw	y
	ld	yl, a
	ldw	(0x03, sp), y
	addw	x, (0x03, sp)
	ldw	(0x03, sp), x
;	../src/uart_tbasic.c: 228: uart_putchar(ch);
	ld	a, (0x02, sp)
	push	a
	call	_uart_putchar
	pop	a
00113$:
;	../src/uart_tbasic.c: 234: if ((ch== 127) || (ch== 8))    // letzte Eingabe loeschen
	ld	a, (0x02, sp)
	cp	a, #0x7f
	jreq	00120$
	ld	a, (0x02, sp)
	cp	a, #0x08
	jrne	00121$
00120$:
;	../src/uart_tbasic.c: 236: if (sum)
;	../src/uart_tbasic.c: 238: sum /= 10;
	ldw	x, (0x03, sp)
	jreq	00118$
	ldw	y, #0x000a
	divw	x, y
	ldw	(0x03, sp), x
;	../src/uart_tbasic.c: 239: uart_putchar(8);
	push	#0x08
	call	_uart_putchar
	pop	a
;	../src/uart_tbasic.c: 240: uart_putchar(' ');
	push	#0x20
	call	_uart_putchar
	pop	a
;	../src/uart_tbasic.c: 241: uart_putchar(8);
	push	#0x08
	call	_uart_putchar
	pop	a
	jra	00121$
00118$:
;	../src/uart_tbasic.c: 244: if (signflag)
	tnz	(0x01, sp)
	jreq	00121$
;	../src/uart_tbasic.c: 246: uart_putchar(8);
	push	#0x08
	call	_uart_putchar
	pop	a
;	../src/uart_tbasic.c: 247: uart_putchar(' ');
	push	#0x20
	call	_uart_putchar
	pop	a
;	../src/uart_tbasic.c: 248: uart_putchar(8);
	push	#0x08
	call	_uart_putchar
	pop	a
;	../src/uart_tbasic.c: 249: signflag= 0;
	clr	(0x01, sp)
00121$:
;	../src/uart_tbasic.c: 254: if ((ch== '-') && (sum == 0))
	ld	a, (0x02, sp)
	cp	a, #0x2d
	jrne	00127$
	ldw	x, (0x03, sp)
	jrne	00127$
;	../src/uart_tbasic.c: 256: signflag= 1;
	ld	a, #0x01
	ld	(0x01, sp), a
;	../src/uart_tbasic.c: 257: uart_putchar('-');
	push	#0x2d
	call	_uart_putchar
	pop	a
00127$:
;	../src/uart_tbasic.c: 260: } while (ch != 0x0d);              // wiederholen bis Returnzeichen eintrifft
	ld	a, (0x02, sp)
	cp	a, #0x0d
	jreq	00233$
	jp	00126$
00233$:
;	../src/uart_tbasic.c: 261: if (signflag) return sum *(-1); else return sum;
	tnz	(0x01, sp)
	jreq	00130$
	ldw	x, (0x03, sp)
	pushw	x
	push	#0xff
	push	#0xff
	call	__mulint
	addw	sp, #4
	.byte 0xc5
00130$:
	ldw	x, (0x03, sp)
00132$:
;	../src/uart_tbasic.c: 262: }
	addw	sp, #4
	ret
	.area CODE
	.area CONST
	.area INITIALIZER
	.area CABS (ABS)
